# /packages/intranet-filestorage-size-indicator/tcl/intranet-filestorage-size-indicator-procs.tcl
#
# Copyright (c) 2015 ]project-open[ (Project Open Business Solutions, S.L.)
#
# All rights reserved. Please check
# http://www.project-open.com/en/project-open-license-commercial
#
# @author frank.bergmann@project-open.com

ad_library {
    @author frank.bergmann@project-open.com
}

# ----------------------------------------------------------------------
# Check the occupied pace
# ----------------------------------------------------------------------

ad_proc -public im_filestorage_size_indicator_sweeper { } {
    Check the space currently occupied by file storage
} {
    ns_log Notice "im_filestorage_size_indicator_sweeper: Starting"

    set pageroot [ns_info pageroot]
    set serverroot [join [lrange [split $pageroot "/"] 0 end-1] "/"]
    set filestorage_path "$serverroot/filestorage/"

    set du_output ""
    if {[catch {
	set du_output [exec /bin/bash -c "du -sk $filestorage_path"]
	ns_log Notice "im_filestorage_size_indicator_sweeper: du_output=$du_output"
    } err_msg]} { 
	ns_log Error "im_filestorage_size_indicator_sweeper: Error executing 'exec /bin/bash -c \"du -sk $filestorage_path\"': $err_msg"
	return
    }
    
    set size [string trim [lindex $du_output 0]]
    if {![string is integer $size]} {
	ns_log Error "im_filestorage_size_indicator_sweeper: 'du' value is not an integer: '$size' as first value from '$du_output'"
	return
    }

    db_dml update_filestorage_size "
	update apm_parameter_values
	set attr_value = trunc(:size / 1024)
	where parameter_id in (
		select	parameter_id
		from	apm_parameters
		where	package_key = 'intranet-filestorage-size-indicator' and 
			parameter_name = 'CurrentlyOccupiedSpaceMB'
		)
    "
}
